git-lfs/t/t-verify.sh
brian m. carlson b2ddccd90d t: avoid using shell variables in printf's first argument
The printf(1) command, like it's C cousin, takes a format string as its
first argument.  If a shell variable is passed as the first argument, it
will be interpreted as a format string; this can lead to surprising
behavior and can cause the test suite to fail if we accidentally insert
a format string character into the variable.

Modify all the places in the individual tests that we use a plain quoted
variable as the format string by running the following Ruby one-liner:

  ruby -i -pe '$_.gsub!(/printf "\$/, %q(printf "%s" "$))' t/t-*.sh

Avoid modifying the test helpers, as there are places (such as calc_oid)
where we want to pass text containing escapes (such as "\n") and have
those be properly interpreted by printf(1).
2018-09-10 14:57:10 +00:00

126 lines
3.0 KiB
Bash
Executable File

#!/usr/bin/env bash
. "$(dirname "$0")/testlib.sh"
begin_test "verify with retries"
(
set -e
reponame="verify-fail-2-times"
setup_remote_repo "$reponame"
clone_repo "$reponame" "$reponame"
git lfs track "*.dat"
git add .gitattributes
git commit -m "initial commit"
contents="send-verify-action"
contents_oid="$(calc_oid "$contents")"
contents_short_oid="$(echo "$contents_oid" | head -c 7)"
printf "%s" "$contents" > a.dat
git add a.dat
git commit -m "add a.dat"
GIT_TRACE=1 GIT_CURL_VERBOSE=1 git push origin master 2>&1 | tee push.log
grep "Authorization: Basic * * * * *" push.log
[ "0" -eq "${PIPESTATUS[0]}" ]
[ "2" -eq "$(grep -c "verify $contents_short_oid attempt" push.log)" ]
)
end_test
begin_test "verify with retries (success without retry)"
(
set -e
reponame="verify-fail-0-times"
setup_remote_repo "$reponame"
clone_repo "$reponame" "$reponame"
git lfs track "*.dat"
git add .gitattributes
git commit -m "initial commit"
contents="send-verify-action"
contents_oid="$(calc_oid "$contents")"
contents_short_oid="$(echo "$contents_oid" | head -c 7)"
printf "%s" "$contents" > a.dat
git add a.dat
git commit -m "add a.dat"
GIT_TRACE=1 GIT_CURL_VERBOSE=1 git push origin master 2>&1 | tee push.log
grep "Authorization: Basic * * * * *" push.log
[ "0" -eq "${PIPESTATUS[0]}" ]
[ "1" -eq "$(grep -c "verify $contents_short_oid attempt" push.log)" ]
)
end_test
begin_test "verify with retries (insufficient retries)"
(
set -e
reponame="verify-fail-10-times"
setup_remote_repo "$reponame"
clone_repo "$reponame" "$reponame"
git lfs track "*.dat"
git add .gitattributes
git commit -m "initial commit"
contents="send-verify-action"
contents_oid="$(calc_oid "$contents")"
contents_short_oid="$(echo "$contents_oid" | head -c 7)"
printf "%s" "$contents" > a.dat
git add a.dat
git commit -m "add a.dat"
set +e
GIT_TRACE=1 git push origin master 2>&1 | tee push.log
if [ "0" -eq "${PIPESTATUS[0]}" ]; then
echo >&2 "verify: expected \"git push\" to fail, didn't ..."
exit 1
fi
set -e
[ "3" -eq "$(grep -c "verify $contents_short_oid attempt" push.log)" ]
)
end_test
begin_test "verify with retries (bad .gitconfig)"
(
set -e
reponame="bad-config-verify-fail-2-times"
setup_remote_repo "$reponame"
clone_repo "$reponame" "$reponame"
# Invalid `lfs.transfer.maxverifies` will default to 3.
git config "lfs.transfer.maxverifies" "-1"
git lfs track "*.dat"
git add .gitattributes
git commit -m "initial commit"
contents="send-verify-action"
contents_oid="$(calc_oid "$contents")"
contents_short_oid="$(echo "$contents_oid" | head -c 7)"
printf "%s" "$contents" > a.dat
git add a.dat
git commit -m "add a.dat"
GIT_TRACE=1 GIT_CURL_VERBOSE=1 git push origin master 2>&1 | tee push.log
grep "Authorization: Basic * * * * *" push.log
[ "0" -eq "${PIPESTATUS[0]}" ]
[ "2" -eq "$(grep -c "verify $contents_short_oid attempt" push.log)" ]
)
end_test